'Translated to RQ from :

'Small Basic  by Jim Klutho based on examples by H Schildt various sources
'use at own risk    for PBCC
'this is a bare bones shell for a command based macro language

'by Walter Samsa
'improvement: mathematical functions, CHR function
'


$OPTIMIZE ON
$TYPECHECK ON
$ESCAPECHARS ON

'- Include files
'$INCLUDE "RAPIDQ2.INC"

CONST fmOpenRead = 0

TYPE Commands  'keyword lookup table
   command AS STRING * 20
   tok AS INTEGER
END TYPE

TYPE Label
   Name AS STRING * RQ_LAB_LEN
   p AS LONG  'points to place to go in source file
END TYPE

TYPE For_Stack
   var AS INTEGER  'counter variable
   target AS INTEGER  'target value
   loc AS LONG
END TYPE


'$DEFINE DEBUG1 0
'$DEFINE DEBUG2 0

'- Declaration
DECLARE SUB _Start

DECLARE SUB atom(byref answer AS DOUBLE)
DECLARE SUB eval_exp(byref answer AS DOUBLE)
DECLARE SUB assignment
DECLARE SUB eval_exp1(byref answer AS DOUBLE)
DECLARE SUB eval_exp2(byref answer AS DOUBLE)
DECLARE SUB eval_exp3(byref answer AS DOUBLE)
DECLARE SUB eval_exp4(byref answer AS DOUBLE)
DECLARE SUB eval_exp5(byref answer AS DOUBLE)
DECLARE SUB eval_exp6(byref answer AS DOUBLE)
DECLARE SUB get_token
DECLARE SUB putback
DECLARE SUB serror(error AS INTEGER)
DECLARE FUNCTION IsDelim(c AS STRING) AS INTEGER
DECLARE FUNCTION IsWhite(c AS STRING) AS INTEGER
DECLARE FUNCTION IsDigit(S AS STRING) AS INTEGER
DECLARE FUNCTION IsAlpha(S AS STRING) AS INTEGER

DECLARE FUNCTION find_var(BYREF s AS STRING) AS DOUBLE
DECLARE FUNCTION find_label() AS STRING

DECLARE FUNCTION gpop() AS LONG
DECLARE SUB gpush(location AS LONG)
DECLARE SUB fpush(i AS For_Stack)
DECLARE SUB fPop
DECLARE SUB exec_print()
DECLARE SUB exec_goto()
DECLARE SUB exec_if()
DECLARE SUB exec_dec()
DECLARE SUB exec_inc()
DECLARE SUB exec_for()
DECLARE SUB exec_next()
DECLARE SUB exec_input()
DECLARE SUB exec_gosub()
DECLARE SUB exec_return()
DECLARE SUB exec_format()
DECLARE SUB scan_labels()
DECLARE SUB find_eol()

'
CONST RQ_NUM_LAB = 100
CONST RQ_LAB_LEN = 10
CONST RQ_FOR_NEST = 25
CONST RQ_SUB_NEST = 25
CONST RQ_NUM_COM = 14
CONST RQ_TABSTOP = 8

'token types
CONST RQ_TEMP = 0
CONST RQ_DELIMITER = 1
CONST RQ_VARIABLE = 2
CONST RQ_NUMBER = 3
CONST RQ_COMMAND = 4
CONST RQ_STRING = 5
CONST RQ_QUOTE = 6
CONST RQ_INTFUNC = 7
CONST RQ_LABEL = 8
CONST RQ_VARISTR = 9
CONST RQ_STRFUNC = 10

'command tokens
CONST RQ_PRINT = 1
CONST RQ_INPUT = 2
CONST RQ_IF = 3
CONST RQ_THEN = 4
CONST RQ_GOTO = 5
CONST RQ_FOR = 6
CONST RQ_NEXT = 7
CONST RQ_TO = 8
CONST RQ_GOSUB = 9
CONST RQ_RETURN = 10
CONST RQ_FORMAT = 11
CONST RQ_INC = 12
CONST RQ_DEC = 13
CONST RQ_END = 14
CONST RQ_EOL = 15
CONST RQ_FINISHED = 16

'Errors
CONST RQ_SERROR = 0
CONST RQ_PARENS = 1
CONST RQ_NOEXP = 2
CONST RQ_DIV_ZERO = 3
CONST RQ_EQUAL_EXP = 4
CONST RQ_NOT_VAR = 5
CONST RQ_LAB_TAB_FULL = 6
CONST RQ_DUP_LAB = 7
CONST RQ_UNDEF_LAB = 8
CONST RQ_THEN_EXP = 9
CONST RQ_TO_EXP = 10
CONST RQ_TOO_MNY_FOR = 11
CONST RQ_NEXT_WO_FOR = 12
CONST RQ_TOO_MNY_GOSUB = 13
CONST RQ_RET_WO_GOSUB = 14
CONST RQ_MISS_QUOTE = 15
CONST RQ_STR_EXP = 16
CONST RQ_UNKNOWN_KEYWORD = 17
CONST RQ_UNKNOWN_FUNCTION = 18

'relational ops
CONST RQ_GE = 1
CONST RQ_NE = 2
CONST RQ_LE = 3

CONST rqPI = 3.14159265358979323846
CONST rqE = 2.71828182845904523536
CONST gtor = 0.01745329251994329576

'- global vars

DIM list AS STRING  		'holds expression to be analyzed
DIM posiz AS INTEGER  	'current position
DIM prog AS QMEMORYSTREAM  'to load the source

DIM token AS STRING		'current token
DIM tok_type AS BYTE
DIM tok AS BYTE

DIM ErrorFlag AS LONG
DEFSTR gSB_Format = "%.2f"

DEFDBL vars(26) = {0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , 0.0 , }
DIM VarStrings(26) AS STRING

DIM Table(RQ_NUM_COM) AS Commands
Table(1).COMMAND = "print"  :  Table(1).tok = RQ_PRINT
Table(2).COMMAND = "input"  :  Table(2).tok = RQ_INPUT
Table(3).COMMAND = "if"  :  Table(3).tok = RQ_IF
Table(4).COMMAND = "then"  :  Table(4).tok = RQ_THEN
Table(5).COMMAND = "goto"  :  Table(5).tok = RQ_GOTO
Table(6).COMMAND = "for"  :  Table(6).tok = RQ_FOR
Table(7).COMMAND = "next"  :  Table(7).tok = RQ_NEXT
Table(8).COMMAND = "to"  :  Table(8).tok = RQ_TO
Table(9).COMMAND = "gosub"  :  Table(9).tok = RQ_GOSUB
Table(10).COMMAND = "return"  :  Table(10).tok = RQ_RETURN
Table(11).COMMAND = "format"  :  Table(11).tok = RQ_FORMAT
Table(12).COMMAND = "inc"  :  Table(12).tok = RQ_INC
Table(13).COMMAND = "dec"  :  Table(13).tok = RQ_DEC
Table(14).COMMAND = "end"  :  Table(14).tok = RQ_END

DIM Relops AS STRING
Relops = CHR$(RQ_GE) + CHR$(RQ_NE) + CHR$(RQ_LE) + "<" + ">" + "=" + CHR$(0) + CHR$(0)

DIM Label_Table(RQ_NUM_LAB) AS Label

DIM fstack(RQ_FOR_NEST) AS For_Stack  'stack for FOR/NEXT loop
DIM fstackRet AS For_Stack

DIM gstack(RQ_SUB_NEST) AS LONG  'stack for gosub

DIM ftos AS INTEGER  'index to top of FOR stack
DIM gtos AS INTEGER  'index to top of GOSUB stack

_Start

FUNCTION Trim$(s AS STRING) AS STRING
   Trim$ = LTRIM$(RTRIM$(s))
END FUNCTION

SUB _Start
   DIM answer AS DOUBLE
   DIM file AS QFILESTREAM

   IF Command$(1) = "" THEN
		Print "Usage: parser1 filename.bas"
      'SHOWMESSAGE "Usage: parser1 filename.bas"
      END
   END IF
   IF FILEEXISTS(Command$(1)) THEN
      file.Open(Command$(1) , fmOpenRead)
   ELSE
		Print "file " + Command$(1) + " don't exist"
      'SHOWMESSAGE "file " + Command$(1) + " don't exist"
      END
   END IF

   prog.CopyFrom(file , file.Size) 'copy file stream to mem stream
   'PRINT "Prog. size " , prog.Size
   file.Close

	'A possible alternative way to obtain the current char position
   'posiz=prog.pointer
   'print posiz
   'posiz=posiz+16
   'print LEFT$(VARPTR$(posiz),1)
   '
   'END
	
   prog.Position = 0  'copy stream to string
   list = prog.ReadStr(prog.Size) + STRING$(7 , CHR$(0)) 'to be sure to exit :)

   scan_labels  'find the labels in the program

   ftos = 0  'initialize the FOR stack index
   gtos = 0  'initialize the GOSUB stack index

   ErrorFlag = 0
   PRINT
   WHILE tok <> RQ_FINISHED AND ErrorFlag = 0
      get_token  'check for assignment statement
      IF tok_type = RQ_VARIABLE OR tok_type = RQ_VARISTR THEN  'a variable
         assignment
      ELSEIF tok_type = RQ_LABEL OR tok_type = RQ_NUMBER THEN
         'Do Nothing
      ELSE  'a command
         SELECT CASE tok
            CASE RQ_PRINT
               exec_print
            CASE RQ_INPUT
               exec_input
            CASE RQ_GOTO
               exec_goto
            CASE RQ_GOSUB
               exec_gosub
            CASE RQ_RETURN
               exec_return
            CASE RQ_FOR
               exec_for
            CASE RQ_NEXT
               exec_next
            CASE RQ_IF
               exec_if
            CASE RQ_FORMAT
               exec_format
            CASE RQ_INC
               exec_inc
            CASE RQ_DEC
               exec_dec
            CASE RQ_END
               END
            CASE RQ_EOL , RQ_LABEL , RQ_FINISHED
               'do nothing
            CASE ELSE
               PRINT "From Start "
               serror(RQ_UNKNOWN_KEYWORD)
         END SELECT
      END IF
   WEND

   'END
END SUB

SUB fpush(i AS For_Stack)
   IF ftos > RQ_FOR_NEST THEN
      PRINT "From fpush "
      serror(RQ_TOO_MNY_FOR)
   ELSE
      fstack(ftos) = i
      ftos ++
   END IF
END SUB

SUB fPop
   ftos --
   IF ftos < 0 THEN
      PRINT "From fPop "
      serror(RQ_NEXT_WO_FOR)
   ELSE
      fstackRet = fstack(ftos)
   END IF
END SUB

SUB exec_next
   DIM i AS For_Stack

   fPop
   INC(vars(fstackRet.var))' = vars(fstackRet.var) + 1
   IF vars(fstackRet.var) > fstackRet.target THEN
      EXIT SUB
   ELSE
      fpush fstackRet
      posiz = fstackRet.Loc
   END IF
END SUB

SUB exec_for
   DIM i AS For_Stack
   DEFDBL Risp

   get_token
   IF RIGHT$(token , 1) = "$" THEN
      PRINT "From exec_for "
      serror(RQ_SERROR)
      EXIT SUB
   END IF

   IF IsAlpha(token) = 0 THEN
      PRINT "From exec_for "
      serror(RQ_NOT_VAR)
      EXIT SUB
   ELSE
      i.var = ASC(UCASE$(token)) - ASC("A")
   END IF

   get_token
   IF token <> "=" THEN
      PRINT "From exec_for "
      serror(RQ_EQUAL_EXP)
      EXIT SUB
   END IF

   eval_exp Risp
   vars(i.var) = INT(Risp)

   get_token
   IF UCASE$(token) <> "TO" THEN
      PRINT "From exec_for "
      serror(RQ_TO_EXP)
      EXIT SUB
   END IF

   eval_exp Risp
   i.Target = INT(Risp)

   IF Risp >= vars(i.var) THEN
      i.loc = posiz
      fpush i
   ELSE
      WHILE tok <> RQ_NEXT
         get_token
      WEND
   END IF
END SUB

SUB Eval_StrExp(BYREF TempStr AS STRING)
   DIM Risult AS LONG
   DIM myStr AS STRING
   DIM NResult AS DOUBLE

   TempStr = ""
   DO
      get_token
      IF tok_type = RQ_VARISTR THEN
         myStr = token
         Risult = find_var(myStr)
         TempStr = TempStr + myStr
         get_token
      ELSEIF tok_type = RQ_QUOTE THEN
         TempStr = TempStr + token
         get_token
      ELSEIF tok_type = RQ_INTFUNC THEN
         SELECT CASE token
            CASE "CHR"
               eval_exp(NResult)
               tempstr = TempStr + CHR$(NResult)
            CASE ELSE
               serror(18)
         END SELECT
         get_token
      ELSEIF tok_type = RQ_VARIABLE OR tok_type = RQ_NUMBER THEN
         putback
         eval_exp NResult
         TempStr = TempStr + FORMAT$(gSB_Format , NResult)
         get_token
      ELSE
         PRINT "From Eval_StrExp "
         serror(RQ_SERROR)
         EXIT SUB
      END IF
   LOOP UNTIL token <> "&"
END SUB

SUB exec_print
   DIM Risp AS DOUBLE
   DIM mylen AS LONG
   DIM spaces AS LONG
   DIM lastdelim AS STRING
   DIM TempStr AS STRING
   DEFSTR temptoken =""
	Lastdelim=""
   mylen = 0
   DO
      get_token  'get next list item
      'print "TtT ",tok_type," ",tok
      IF tok_type = RQ_QUOTE OR tok_type = RQ_VARISTR OR tok_type = RQ_STRFUNC THEN  'is string
         putback
         IF tok_type = RQ_QUOTE THEN posiz = posiz - 2
         Eval_StrExp TempStr
         PRINT TempStr;
         mylen = mylen + LEN(TempStr)
      ELSEIF tok = RQ_EOL OR tok = RQ_FINISHED THEN
         'Print
      ELSE  'expression
         putback
         eval_exp Risp
         get_token
         TempStr = STR$(Risp)
         PRINT TempStr;
         mylen = mylen + LEN(TempStr)
      END IF
					
		IF token <> "EL" Then temptoken=token
		
      IF token = "," THEN
         spaces = RQ_TABSTOP - (mylen MOD RQ_TABSTOP)
         mylen = mylen + spaces
         PRINT CHR$(9) ;  'SPACE$(spaces) ;
      ELSEIF token = ";" THEN
         mylen = mylen + 1
         PRINT "";
      ELSEIF tok <> RQ_EOL AND tok <> RQ_FINISHED THEN
         PRINT "From exec_print "
         serror(RQ_SERROR)
      END IF
      IF tok = RQ_EOL OR tok = RQ_FINISHED THEN
			IF temptoken = ";" THEN lastdelim = temptoken
         EXIT DO
      END IF

   LOOP
   IF tok = RQ_EOL OR tok = RQ_FINISHED THEN
      IF lastdelim <> ";" THEN PRINT
   ELSE
      PRINT "From exec_print "
      serror(RQ_SERROR)
   END IF
END SUB

SUB exec_inc
	DEFINT k,slot
	get_token
	IF IsAlpha(token)=1 THEN
		slot = ASC(UCASE$(token)) - ASC("A")
		k=find_var(token)
		vars(slot) = k+1
	END IF
END SUB

SUB exec_dec
	DEFINT k,slot
	get_token
	IF IsAlpha(token)=1 THEN
		slot = ASC(UCASE$(token)) - ASC("A")
		k=find_var(token)
		vars(slot) = k-1
	END IF
END SUB

SUB exec_if
   DEFDBL x

   eval_exp x
   IF x = - 1 THEN
      get_token
      IF tok <> 4 THEN
         PRINT "From exec_if "
         serror(RQ_THEN_EXP)
      END IF
   ELSE
      find_eol
   END IF
END SUB

SUB exec_input
   DEFSTR s=""
   DEFINT i=0

   get_token
   IF tok_type = RQ_QUOTE THEN
      PRINT token ;
      get_token
      IF token <> "," THEN
         PRINT "From exec_input "
         serror(RQ_SERROR)
         EXIT SUB
      END IF
      get_token
   ELSE
      PRINT "?  ";
   END IF
   i = ASC(UCASE$(MID$(token , 1 , 1))) - ASC("A")
   INPUT ""; s
   IF tok_type = RQ_VARIABLE THEN
      vars(i) = VAL(s)
   ELSE
      VarStrings(i) = s
   END IF
END SUB

FUNCTION FindLabel(s AS STRING) AS LONG
   DEFLNG count
   DEFSTR mystr = s

   FindLabel = 0  'Assume Failure
   FOR count = 1 TO RQ_NUM_LAB
      IF Trim$(Label_Table(count).Name) = mystr THEN
         FindLabel = Label_Table(count).p  'Found it
         EXIT FUNCTION
      END IF
   NEXT count
END FUNCTION

SUB exec_goto
   DEFLNG NewProgPtr
   get_token
   NewProgPtr = FindLabel(token)
   IF NewProgPtr = 0 THEN
      PRINT "from exec_goto "
      serror(RQ_UNDEF_LAB)
   ELSE
      posiz = NewProgPtr
   END IF
END SUB

FUNCTION gpop() AS LONG

   IF gtos = 0 THEN
      PRINT "from gpop "
      serror(RQ_RET_WO_GOSUB)
   ELSE
      result = gstack(gtos)
      gtos --
   END IF
END FUNCTION

SUB exec_return
   posiz = gpop
   'PRINT "the return is ",posiz
END SUB

SUB gpush(Location AS LONG)
   gtos ++
   IF gtos = RQ_SUB_NEST THEN
      PRINT "from gpush "
      serror(RQ_TOO_MNY_GOSUB)
   ELSE
      gstack(gtos) = Location
   END IF

END SUB

SUB exec_gosub
   DEFLNG Location

   get_token
   Location = FindLabel(token)
   IF Location = 0 THEN
      PRINT "from exec_gosub "
      serror(RQ_UNDEF_LAB)
   ELSE
      gpush(posiz)
      posiz = Location
   END IF
END SUB

'Find the start of the next line.
SUB find_eol()

   WHILE list[posiz] <> "\r" AND list[posiz] <> CHR$(0)
      posiz ++
   WEND
   IF list[posiz] > 0 THEN
      posiz = posiz + 2
   END IF

END SUB

'Return index of next free position in label array.
'A -1 is returned if the array is full.
'A -2 is returned when duplicate label is found.
FUNCTION get_next_label(s AS STRING) AS INTEGER
   DEFINT t

   get_next_label = - 1
   FOR t = 1 TO RQ_NUM_LAB
      IF Label_Table(t).p = 0 THEN
         get_next_label = t
         EXIT FUNCTION
      ELSEIF Label_Table(t).Name = s THEN
         get_next_label = - 2  'dup
         EXIT FUNCTION
      END IF
   NEXT
END FUNCTION

'Find all labels.
SUB scan_labels()
   DEFINT i

   'zero all labels
   FOR i = 1 TO RQ_NUM_LAB
      Label_Table(i).Name = ""
      Label_Table(i).p = 0
   NEXT
   i = 0

   'if the first token in the file is a label
   posiz = 1
   get_token
   IF (tok_type = RQ_LABEL OR tok_type = RQ_NUMBER) THEN
      Label_Table(1).Name = token
      Label_Table(1).p = posiz
   END IF
   find_eol
   WHILE tok <> RQ_FINISHED
      get_token
      IF (tok_type = RQ_LABEL OR tok_type = RQ_NUMBER) THEN
         i = get_next_label(token)
         IF i = - 1 THEN serror(RQ_LAB_TAB_FULL)  :  EXIT SUB
         IF i = - 2 THEN serror(RQ_DUP_LAB)  :  EXIT SUB
         Label_Table(i).Name = token
         Label_Table(i).p = posiz  'current point in program
      END IF
      'if not on a blank line, find next line
      IF tok <> RQ_EOL THEN find_eol
   WEND
   posiz = 1
   tok = 0

END SUB


'Entry point into parser
SUB eval_exp(byref answer AS DOUBLE)
   $IFDEF DEBUG1
      PRINT ">eval_exp"
   $ENDIF
   get_token

   IF token = "EOF" THEN
      PRINT "from eval_exp "
      serror(RQ_NOEXP)
      EXIT SUB
   ELSE
      eval_exp1(answer)
      putback
   END IF

   $IFDEF DEBUG2
      PRINT "eval_exp>"
   $ENDIF
END SUB


'Assign a variable a value.
SUB assignment
   $IFDEF DEBUG1
      PRINT ">eval_exp1"
   $ENDIF

   DEFINT slot
   DEFSTR temp_token , MyStr , TempStr
   DEFDBL answer1

   'get the variable name
   TempStr = token
   MyStr = UCASE$(LEFT$(token , 1))

   slot = ASC(UCASE$(token)) - ASC("A")
   'get the equal sign
   get_token
   IF token <> "=" THEN
      PRINT "from assignment "
      serror(RQ_EQUAL_EXP)
      EXIT SUB
   ELSE

      IF RIGHT$(TempStr , 1) <> "$" THEN
         eval_exp(answer1) 'get the value to assign to var
         vars(slot) = answer1
      ELSE
         eval_StrExp TempStr
         VarStrings(slot) = TempStr
      END IF
   END IF
   $IFDEF DEBUG2
      PRINT "eval_exp1>"
   $ENDIF
END SUB

SUB eval_exp1(byref answer AS DOUBLE) 'RELATIONAL
   DEFDBL Temp
   DEFSTR Op
   DEFLNG which
   DEFLNG temp2

   eval_exp2(answer)
   Op = token
   which = INSTR(1 , Relops , Op)
   IF which > 0 THEN
      get_token
      eval_exp1(Temp)
      SELECT CASE Op
         CASE "<"
            answer = (answer < Temp)
         CASE CHR$(RQ_LE)
            answer = (answer <= Temp)
         CASE ">"
            answer = (answer > Temp)
         CASE CHR$(RQ_GE)
            answer = (answer >= Temp)
         CASE "="
            answer = (answer = Temp)
         CASE CHR$(RQ_NE)
            answer = (answer <> Temp)
      END SELECT
   END IF
END SUB


'Add or subtract two terms.
SUB eval_exp2(byref answer AS DOUBLE)
   $IFDEF DEBUG1
      PRINT ">eval_exp2"
   $ENDIF

   DIM op AS STRING
   DIM temp AS DOUBLE

   eval_exp3(answer)
   op = token
   WHILE op = "+" OR op = "-"
      get_token
      eval_exp3(temp)
      SELECT CASE op
         CASE "+"
            answer = answer + temp
         CASE "-"
            answer = answer - temp
      END SELECT
      op = token
   WEND
   $IFDEF DEBUG2
      PRINT "eval_exp2>"
   $ENDIF

END SUB

'Multiply or divide two factors.
SUB eval_exp3(byref answer AS DOUBLE)
   $IFDEF DEBUG1
      PRINT ">eval_exp3"
   $ENDIF

   DIM op AS STRING
   DIM temp AS DOUBLE

   eval_exp4(answer)
   op = token
   WHILE op = "*" OR op = "/" OR op = "%"
      get_token
      eval_exp4(temp)
      SELECT CASE op
         CASE "*"
            answer = answer * temp
         CASE "/"
            answer = answer / temp
         CASE "%"
            answer = answer MOD temp
      END SELECT
      op = token
   WEND
   $IFDEF DEBUG2
      PRINT "eval_exp3>"
   $ENDIF

END SUB

'Is a unary + or -.
SUB eval_exp4(byref answer AS DOUBLE)
   $IFDEF DEBUG1
      PRINT ">eval_exp4"
   $ENDIF

   DIM op AS STRING
   op = ""
   IF tok_type = RQ_DELIMITER AND (token = "+" OR token = "-") THEN
      op = token
      get_token
   END IF
   eval_exp5(answer)
   IF op = "-" THEN answer = - answer
   $IFDEF DEBUG2
      PRINT "eval_exp4>"
   $ENDIF

END SUB

'Process integer exponent.
SUB eval_exp5(byref answer AS DOUBLE)
   $IFDEF DEBUG1
      PRINT ">eval_exp5"
   $ENDIF

   DIM t AS INTEGER
   DIM base AS DOUBLE , ex AS DOUBLE
   DEFSTR sTmp

   eval_exp6(answer)
   IF token = "^" THEN
      get_token
      eval_exp4(ex)
      base = answer
      IF ex = 0.0 THEN
         answer = 1.0
      ELSEIF base = 0.0 AND (ex > 0.0) THEN
         answer = 0.0
      ELSE
         answer = base^ex
      END IF
   END IF
   $IFDEF DEBUG2
      PRINT "eval_exp5>"
   $ENDIF

END SUB

'Process parenthesized expression.
SUB eval_exp6(byref answer AS DOUBLE)
   $IFDEF DEBUG1
      PRINT ">eval_exp6"
   $ENDIF

   IF token = "(" THEN
      get_token
      eval_exp2(answer)
      IF token <> ")" THEN serror(RQ_PARENS)
      get_token
   ELSE
      atom(answer)
   END IF
   $IFDEF DEBUG2
      PRINT "eval_exp6>"
   $ENDIF

END SUB

'Find value of number , variable...
SUB atom(byref answer AS DOUBLE)
   DIM rad AS DOUBLE
   DIM TmpDbl AS DOUBLE
   DIM temptok AS STRING

   $IFDEF DEBUG1
      PRINT ">atom"
   $ENDIF

   IF tok_type = RQ_NUMBER THEN
      answer = VAL(token)
      get_token
   ELSEIF tok_type = RQ_VARIABLE THEN
      answer = find_var(token)
      get_token
   ELSEIF tok_type = RQ_INTFUNC THEN
      temptok = token
      get_token
      SELECT CASE UCASE$(temptok)
			CASE "TIMER"
				answer=TIMER
         CASE "ABS"
            eval_exp5(TmpDbl)
            answer = ABS(TmpDbl)
         CASE "COS"
				'eval_cos
            eval_exp5(TmpDbl)
            SELECT CASE TmpDbl
               CASE 0
                  answer = 1
               CASE 90
                  answer = 0
               CASE 180
                  answer = - 1
               CASE 270
                  answer = 0
               CASE ELSE
                  rad = gtor * TmpDbl
                  answer = COS(rad)
            END SELECT
         CASE "SIN"
				'eval_sin
            eval_exp5(TmpDbl)
            SELECT CASE TmpDbl
               CASE 0 , 360
                  answer = 0
               CASE 90
                  answer = 1
               CASE 180
                  answer = 0
               CASE 270
                  answer = - 1
               CASE ELSE
                  rad = gtor * TmpDbl
                  answer = SIN(rad)
            END SELECT
         CASE "SQR"
            eval_exp5(TmpDbl)
            answer = SQR(TmpDbl)
            'answer=TmpDbl^(1/2)
            'answer = RQD(TmpDbl)
         CASE "TAN"
            eval_exp5(TmpDbl)
            rad = gtor * TmpDbl
            answer = TAN(rad)
         CASE "INT"
            eval_exp5(TmpDbl)
            answer = INT(TmpDbl)
         CASE "LOG"
            eval_exp5(TmpDbl)
            answer = LOG(TmpDbl)
         CASE ELSE
            SHOWMESSAGE "To do"
      END SELECT
   ELSE
      PRINT
      PRINT "from atom: "
      serror(RQ_SERROR)
   END IF
   $IFDEF DEBUG2
      PRINT "atom>"
   $ENDIF

END SUB

'Look up a token's internal representation in the token table.
FUNCTION look_up(s AS STRING) AS INTEGER

   DEFINT i
   DEFSTR temp

   'convert TO lowercase
   temp = LCASE$(s)
   'see IF token IS in table
   FOR i = 1 TO RQ_NUM_COM
      IF Trim$(Table(i).COMMAND) = Trim$(temp) THEN
         look_up = Table(i).tok
         EXIT FUNCTION
      ELSE
         look_up = 0
      END IF
   NEXT
END FUNCTION

'get a token
SUB get_token
   $IFDEF DEBUG1
      PRINT ">get_token"
   $ENDIF
   DEFINT i
   token = ""
   tok_type = 0
   tok = 0

   IF list[posiz] = CHR$(0) THEN  'OR posiz >= addr THEN  'end of file
      token = "EOF"
      tok_type = RQ_DELIMITER
      tok = RQ_FINISHED
      EXIT SUB
   END IF

   WHILE IsWhite(list[posiz]) = 1  'skip over white space
      posiz ++
   WEND

   IF list[posiz] = "'" THEN  'skip over comment
      find_eol
   END IF

   IF list[posiz] = "\r" THEN  'crlf
      posiz ++
      posiz ++
      tok = RQ_EOL
      tok_type = RQ_DELIMITER
      token = "EL"
      EXIT SUB
   END IF

   IF IsDelim(list[posiz]) = 1 THEN
      tok_type = RQ_DELIMITER
      token = list[posiz]
      posiz ++

   ELSEIF list[posiz] = CHR$(34) THEN  'QUOTED STRING
      posiz ++
      WHILE list[posiz] <> CHR$(34) AND list[posiz] <> CHR$(13)
         token = token + list[posiz]
         posiz ++
      WEND
      IF list[posiz] = CHR$(13) THEN
         PRINT "from get_token "
         serror(RQ_MISS_QUOTE)
         posiz ++
      END IF
      posiz ++
      tok_type = RQ_QUOTE
   ELSEIF IsDigit(list[posiz]) = 1 THEN
      WHILE IsDelim(list[posiz]) = 0
         token = token + list[posiz]
         posiz ++
      WEND
      tok_type = RQ_NUMBER
   ELSEIF IsAlpha(list[posiz]) = 1 THEN
      WHILE IsDelim(list[posiz]) = 0
         token = token + list[posiz]
         posiz ++
      WEND
      tok_type = RQ_STRING
   END IF

   IF tok_type = RQ_STRING THEN
      tok = look_up(token)
      IF tok = 0 THEN
         IF RIGHT$(token , 1) = "$" THEN
            tok_type = RQ_VARISTR
         ELSEIF RIGHT$(token , 1) = ":" THEN
            tok_type = RQ_LABEL
            tok = RQ_LABEL
            i = LEN(token)
            token = MID$(token , 1 , i - 1) 'strip ":"
         ELSE
            SELECT CASE UCASE$(token)
               CASE "ABS" , "ACOS" , "ASIN" , "ATAN" , "COS" , "SIN" , "SQR" , "TAN" , "INT" , "LOG" , "CHR", "TIMER"
                  tok_type = RQ_INTFUNC
               CASE "CHR"
                  tok_type = RQ_STRFUNC
               CASE ELSE
                  tok_type = RQ_VARIABLE
            END SELECT
         END IF
      ELSE
         tok_type = RQ_COMMAND
      END IF
   END IF
   $IFDEF DEBUG2
   PRINT "token " , token , ASC(token)
   $ENDIF
END SUB

'Return a token to input stream
SUB putback

   DIM temp AS STRING
   DIM k AS INTEGER
   temp = token

   FOR k = 1 TO LEN(temp)
      posiz --
   NEXT
END SUB

'display an error message
SUB serror(error AS INTEGER)
   DIM temp AS STRING

   DIM TempPtr AS LONG
   DIM char AS STRING
   DIM MyLine AS LONG

   SELECT CASE error
      CASE 0
         temp = " :Syntax error"
      CASE 1
         temp = ": Unbalanced parentheses"
      CASE 2
         temp = ": No expression present"
      CASE 3
         temp = ": Division by Zero"
      CASE 4
         temp = ": Equals sign expected"
      CASE 5
         temp = ": Not a variable"
      CASE 6
         temp = ": Label table full"
      CASE 7
         temp = ": Duplicate label"
      CASE 8
         temp = ": Undefined label"
      CASE 9
         temp = ": THEN expected"
      CASE 10
         temp = ": TO expected"
      CASE 11
         temp = ": Too many nested FOR loops"
      CASE 12
         temp = ": NEXT without FOR"
      CASE 13
         temp = ": Too many nested GOSUBs"
      CASE 14
         temp = ": RETURN without GOSUB"
      CASE 15
         temp = ": Missing Quote"
      CASE 16
         temp = ": String Expected"
      CASE 17
         temp = ": Unknown Keyword"
      CASE 18
         temp = ": Unknown Function"
   END SELECT
   TempPtr = posiz
   char = ""
   posiz = 1
   MyLine = 1

   WHILE posiz < TempPtr AND char <> CHR$(0)
      char = list[posiz]
      IF char = CHR$(13) AND list[posiz + 1] = CHR$(10) THEN
         posiz ++
         MyLine ++
      END IF
      posiz ++
   WEND
   PRINT
   PRINT "Error " + STR$(error) + temp + " in line " + STR$(MyLine)
   posiz = TempPtr
   ErrorFlag = 1

END SUB

'Return true if c is a delimiter.
FUNCTION IsDelim(c AS STRING) AS INTEGER
   SELECT CASE c
      CASE "+" , "-" , "*" , "/" , "%" , "&" , "^" , "=" , "(" , ")" , " " , ";" , "," , "<" , ">" , CHR$(9) , CHR$(13) , CHR$(10) , CHR$(0)
         IsDelim = 1
      CASE ELSE
         IsDelim = 0
   END SELECT
END FUNCTION

'Return 1 if c is space or tab.
FUNCTION IsWhite(c AS STRING) AS INTEGER
   SELECT CASE c
      CASE " " , CHR$(9)
         IsWhite = 1
      CASE ELSE
         IsWhite = 0
   END SELECT
END FUNCTION

'Return 1 if s is a digit
FUNCTION IsDigit(s AS STRING) AS INTEGER
   IF s >= "0" AND s <= "9" THEN
      IsDigit = 1
   ELSE
      IsDigit = 0
   END IF
END FUNCTION

'Return 1 if s is an alpha char
FUNCTION IsAlpha(s AS STRING) AS INTEGER
   IF (UCASE$(s) >= "A" AND UCASE$(s) <= "Z") THEN 'OR(s >= "a" AND s <= "z") THEN
      IsAlpha = 1
   ELSE
      IsAlpha = 0
   END IF
END FUNCTION

'Find the value of a variable.
FUNCTION find_var(BYREF s AS STRING) AS DOUBLE
   IF IsAlpha(s) = 0 THEN
      PRINT "find_var "
      serror(4)
      EXIT FUNCTION
   END IF

   IF tok_type = RQ_VARISTR THEN  'Result is returned in parameter for strings
      s = VarStrings(ASC(UCASE$(s)) - ASC("A"))
      find_var = - 2
   ELSE
      find_var = vars(ASC(UCASE$(s)) - ASC("A"))
   END IF
END FUNCTION


